"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AdditionalFindingsClinicalReport(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "genomicInterpretation",
        "participantId",
        "referenceDatabasesVersions",
        "reportingDate",
        "softwareVersions",
        "user",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "additionalAnalysisPanels": reports_6_6_0.AdditionalAnalysisPanel,
            "chromosomalRearrangements": reports_6_6_0.ChromosomalRearrangement,
            "karyotypes": reports_6_6_0.Karyotype,
            "shortTandemRepeats": reports_6_6_0.ShortTandemRepeat,
            "structuralVariants": reports_6_6_0.StructuralVariant,
            "uniparentalDisomies": reports_6_6_0.UniparentalDisomy,
            "variants": reports_6_6_0.SmallVariant,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "org.gel.models.report.avro.AdditionalAnalysisPanel": reports_6_6_0.AdditionalAnalysisPanel,
            "org.gel.models.report.avro.ChromosomalRearrangement": reports_6_6_0.ChromosomalRearrangement,
            "org.gel.models.report.avro.Karyotype": reports_6_6_0.Karyotype,
            "org.gel.models.report.avro.ShortTandemRepeat": reports_6_6_0.ShortTandemRepeat,
            "org.gel.models.report.avro.StructuralVariant": reports_6_6_0.StructuralVariant,
            "org.gel.models.report.avro.UniparentalDisomy": reports_6_6_0.UniparentalDisomy,
            "org.gel.models.report.avro.SmallVariant": reports_6_6_0.SmallVariant,
            "org.gel.models.report.avro.AdditionalFindingsClinicalReport": reports_6_6_0.AdditionalFindingsClinicalReport,
        }

    __slots__ = [
        "genomicInterpretation",
        "participantId",
        "referenceDatabasesVersions",
        "reportingDate",
        "softwareVersions",
        "user",
        "additionalAnalysisPanels",
        "chromosomalRearrangements",
        "karyotypes",
        "references",
        "shortTandemRepeats",
        "structuralVariants",
        "uniparentalDisomies",
        "variants",
    ]

    def __init__(
        self,
        genomicInterpretation,
        participantId,
        referenceDatabasesVersions,
        reportingDate,
        softwareVersions,
        user,
        additionalAnalysisPanels=None,
        chromosomalRearrangements=None,
        karyotypes=None,
        references=None,
        shortTandemRepeats=None,
        structuralVariants=None,
        uniparentalDisomies=None,
        variants=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_6_0.AdditionalFindingsClinicalReport model.

        :param genomicInterpretation:
            Summary of the interpretation, this should reflect the positive
            conclusions of this interpretation
        :type genomicInterpretation: str
        :param participantId:
            This is the unique identifier (i.e.: in case of additionalFindings can
            be participantId)
        :type participantId: str
        :param referenceDatabasesVersions:
            This map contains the versions of the different databases used in the
            process, being the database names the keys and the
            versions the values.
        :type referenceDatabasesVersions: dict[str, str]
        :param reportingDate:
            Date of this report in format YYYY-MM-DD
        :type reportingDate: str
        :param softwareVersions:
            This map contains the versions of the different software systems used
            in the process, being the software names the keys and the
            versions the values.
        :type softwareVersions: dict[str, str]
        :param user:
            Author of this report
        :type user: str
        :param additionalAnalysisPanels:
            The list of panels analysed to generate this report
        :type additionalAnalysisPanels: None | list[AdditionalAnalysisPanel]
        :param chromosomalRearrangements:
            List of complex structural reported variants (chomosomal
            rearrangement)
        :type chromosomalRearrangements: None | list[ChromosomalRearrangement]
        :param karyotypes:
            List of inferred karyotypes across all the individuals in this report
        :type karyotypes: None | list[Karyotype]
        :param references:
            Supporting evidence (pubmed identifiers)
        :type references: None | list[str]
        :param shortTandemRepeats:
            List of short tandem repeat variants
        :type shortTandemRepeats: None | list[ShortTandemRepeat]
        :param structuralVariants:
            List of simple structural reported variants (duplications, deletions,
            insertions, inversions, CNVs)
        :type structuralVariants: None | list[StructuralVariant]
        :param uniparentalDisomies:
            List of uniparental disomies across all the individuals in this report
        :type uniparentalDisomies: None | list[UniparentalDisomy]
        :param variants:
            List of small reported variants
        :type variants: None | list[SmallVariant]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.6.0"
